﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using System.Windows.Messaging;

namespace LocalMessageCS.SideBar
{
    public partial class MainPage : UserControl
    {
        //メッセージ受信インスタンス
        LocalMessageReceiver messageReceiver =
            new LocalMessageReceiver("receiver1");

        //コンストラクタ
        public MainPage()
        {
            InitializeComponent();

            //メッセージ受信時のイベント・ハンドラを設定
            messageReceiver.MessageReceived += messageReceiver_MessageReceived;
            try
            {
                //レシーバを受信待ちにする
                messageReceiver.Listen();
            }
            catch (ListenFailedException)
            {
                MessageBox.Show(
                    "レシーバ名が重複しています。",
                    "LocalMessageReceiver", 
                    MessageBoxButton.OK);
            }
        }

        //メッセージ受信時
        void messageReceiver_MessageReceived(object sender, MessageReceivedEventArgs e)
        {
            //サイドバーを初期化する
            Side.Children.Clear();

            //サイドバーにボタンを3個追加する
            for (int i = 0; i < 3; i++)
            {
                Button b = new Button();
                //受け取ったメニューの名前を利用して
                //サイドバーのボタンの名前を設定する
                b.Content = string.Format("[{0}] {1}", e.Message, i);
                    
                //Xaml側に定義したスタイルを設定する
                b.Style = this.Resources["Side"] as Style;
                
                //クリック時のイベント・ハンドラを設定
                b.Click += delegate { MessageBox.Show(string.Format("{0} clicked!", b.Content)); };
                
                //サイドバーに追加する
                Side.Children.Add(b);
            }
        }
    }
}
